import difflib
import re

# FIXME: A nicer diff is on hold for the time being. This just calls
# out to _mdiff and formats it "nicely". But if two "lines" are more
# than .75 different, it just shows a "subtracted this one" and "added
# this one". Not useful and there's no way to change the constant in
# today's difflib.
#
# Also, if you're processing input from HTML forms, odds are the
# "lines" aren't going to be themselves useful. Assuming input of RST
# is a little rude but if you do that, you can do smarter things, but
# I don't know exactly what they are and I don't want to spend more
# time right now working on it.
#
# Future possibilities include: break on paragraph boundaries (\n\n),
# reflow text, and then diff? Diff on words when paragraphs are found
# different? Not sure..

SEPARATOR = re.compile('[\t ]*[^\s]+[\t ]*\n?')

def mysplit(s):
    return s.splitlines(True)
    #return SEPARATOR.findall(s)

differ = difflib.Differ()

def Diff(s1, s2):
    '''FIXME: Make these LockersObjects?

    Probably not; comparing LockersObjects is a big job and should
    probably be addressed by leaving descriptive commit messages in
    YAML with explanations of what happened.'''
    return difflib._mdiff(mysplit(s1), mysplit(s2))

def escape_html(line):
    return line.replace('&', '&amp;').replace('<', '&lt;').replace('>', '&gt;')

class FormatDiff(object):
    def __init__(self, s1, s2):
        self.rows = []
        for line in Diff(s1, s2):
            print line
            fromtuple, totuple, flag = line
            if flag == None:
                self.separator()
            elif flag == False:
                self.no_diff(fromtuple, totuple)
            elif flag == True:
                self.different(fromtuple, totuple)

    def separator(self):
        self.rows.append('<tr></tr>')

    def no_diff(self, fromtuple, totuple):
        fromline, fromtext = fromtuple
        toline, totext = totuple
        assert(fromtext == totext)
        self.rows.append('<tr><td span="2" />'+escape_html(fromtext)+'</td></tr>')

    def different(self, fromtuple, totuple):
        fromline, fromtext = fromtuple
        toline, totext = totuple
        self.rows.append('<tr><td>'+escape_html(fromtext)+'</td><td>'+escape_html(totext)+'</td></tr>')

    def render(self):
        return ''.join(self.rows).replace('\0+','<span class="diff_add">'). \
            replace('\0-','<span class="diff_sub">'). \
            replace('\0^','<span class="diff_chg">'). \
            replace('\1','</span>')


