
def advance_list(current, maximum):
    '''Advance a list of numbers.

    >>> x = [0, 0, 0]
    >>> max = [4, 3, 2]
    >>> advance_list(x, max)
    [0, 0, 1]
    >>> advance_list(x, max)
    [0, 1, 0]
    >>> x = [0, 2, 1]
    >>> advance_list(x, max)
    [1, 0, 0]
    >>> x = [3, 2, 1]
    >>> advance_list(x, max)
    [0, 0, 0]
    '''
    for i in reversed(range(len(current))):
        current[i] += 1
        if current[i] < maximum[i]:
            break
        current[i] = 0
        return current

def tuple_to_list(tpl):
    '''Recursively explore a tuple, converting lists to tuples.'''
    if not isinstance(tpl, tuple): return tpl
    return [tuple_to_list(t) for t in tpl]

def list_to_tuple(lst):
    if not isinstance(lst, list): return lst
    for i in range(len(lst)):
        lst[i] = list_to_tuple(lst[i])
    return tuple(lst)
