import hashlib
import random
from models import fields, models
import node
#from Request import LockersRequest

class TagObject_1(models.LockersObject):
    relative_tags = [fields.StrField()]
    absolute_tags = [fields.StrField()]

    def save(self, *args, **kwargs):
        # If we're saving to a relative path, we need to take all the 
        # relative tags and combine them.
        # FIXME: still a crappy API.
        if self.get_node().path.split('/')[-1] == 'HEAD':
            self.index.absolute_tags = self.index.relative_tags + self.index.absolute_tags
        if 'relative_tags' in self.index.__dict__:
            del self.index.relative_tags
        super(TagObject_1, self).save(*args, **kwargs)

class TagFactory(models.ModelFactory):
    basename = 'TagObject'
    def get(self, *args, **kwargs):
        if len(args) >= 2:
            if isinstance(args[1], node.Node):
                return self.get_node(*args, **kwargs)
        return super(TagFactory, self).get(*args, **kwargs)

    def get_node(self, t, node, *args, **kwargs):
        # FIXME: add smartness; get the most-current-version of node
        # as of node.revision and use that revision instead
        # FIXME: add a kwarg called 'absolute', and do the above
        node = node.push('tags')
        rev = node.revision
        if not rev:
            rev = t.current_revision()

        # Relative tags: HEAD from revision
        rel_node = node.child('HEAD')
        rel_node.revision = node.revision
        tagobj = super(TagFactory, self).get(t, rel_node)
        rel_tags = tagobj.index.absolute_tags

        # Absolute tags: rev_id from current revision
        abs_node = node.child(rev)
        abs_node.revision = None
        tagobj = super(TagFactory, self).get(t, abs_node)
        abs_tags = tagobj.index.absolute_tags

        # Returned object: revision None for correct saving, but
        # rev_id in path
        real_node = node.child(node.revision or 'HEAD')
        real_node.revision = None
        tagobj = super(TagFactory, self).get(t, real_node)
        tagobj.index.absolute_tags = abs_tags
        tagobj.index.relative_tags = rel_tags

        return tagobj

TagObject = TagFactory()

