from __future__ import with_statement
import datetime
from lockers import application
from lockers.dumper import yaml_dump
from webob import Response
from webob.exc import *

class EchoModule(application.LockersApplication):
    '''Lockers module for seeng what's up.'''
    def __init__(self):
        super(EchoModule, self).__init__()

    def __call__(self, request):
        super(EchoModule, self).__call__(request)
        node = request.node
        data = {'session': request.session,
                'cookies': request.COOKIES,
                'query': dict.copy(request.GET),
                'post': dict.copy(request.POST),
                'revision': self.backend.current_revision(),
                }

        s = yaml_dump(data)

        return Response(s, content_type="text/plain")

__echo = EchoModule
