from __future__ import with_statement
from lockers import application
import lockers.node
from lockers.format.rst import RST
from webob import Response
import webob.exc
from lockers.vcs import FileNotFoundError, VCSException
from lockers.models.models import Changeset, LockersObject, DoesNotExistError, ModelFactory, ChangesetFactory
from lockers.template import render_to_response
from contrib.django import newforms

import traceback

class MyChangeset_1(Changeset):
    pass

MyChangeset = ChangesetFactory('MyChangeset')

class MyObject_1(LockersObject):
    '''The parts of a FileObject are:

    meta: dict of metainfo, including upload time, filename, mimetype,
        description.. what else? Size?
    index: the file itself'''
    # FIXME: don't encourage this
    COMMENT = MyChangeset

MyObject = ModelFactory('MyObject')

class MyForm(newforms.Form):
    file = newforms.FileField()
    description = newforms.CharField(widget=newforms.Textarea, required=False)
    unpack = newforms.BooleanField()

class MyApplication(application.LockersApplication):
    '''Lockers module for uploading/downloading files.'''
    def __init__(self):
        super(MyApplication, self).__init__()
        self.rst = RST()

    def __call__(self, request):
        super(MyApplication, self).__call__(request)
        node = request.node
        if node.path == 'thing1':
            return render_to_response('main.html', {
                    'title': "Got thing1"
                    })
            

        return render_to_response('main.html', {
                'title': 'OK'
                })

_skel = MyApplication
