from os.path import join
import paste.fileapp
from lockers import application
from webob import Response

class AssetsApplication(application.LockersApplication):
    def __init__(self):
        super(AssetsApplication, self).__init__()
        self.static_assets = paste.fileapp.DirectoryApp(join(application.LOCKERSROOT, 'templates', 'assets'))
        self.dynamic_assets = None

    def __call__(self, request):
        super(AssetsApplication, self).__call__(request)
        if not self.dynamic_assets:
            try:
                self.dynamic_assets = paste.fileapp.DirectoryApp(join(application.REPOROOT, 'templates', 'assets'))
            except:
                self.dynamic_assets = None
        if self.dynamic_assets:
            results = request.call_application(self.dynamic_assets)
            status, headers, app_iter = results
            stat_num = int(status.split()[0])
            if 200 <= stat_num < 300:
                return Response(status=status, headerlist=headers, app_iter=app_iter)
        status, headers, app_iter = request.call_application(self.static_assets)
        return Response(status=status, headerlist=headers, app_iter=app_iter)

assets = AssetsApplication
