from __future__ import with_statement
import sys
import os.path
import paste.reloader
paste.reloader.install()
paste.reloader.watch_file(__file__)

sys.path.insert(0, os.path.abspath('contrib'))
import django.conf
# FIXME: refactor this out; it's shared between here and TestSupport
import lockers.django_conf

#from paste.urlparser import URLParser, make_directory, load_module, make_py
from lockers.urlparser import URLParser
from webob import Response
from paste.evalexception import EvalException

import lockers.request
from lockers import session

#sys.path.append('.')

DEVEL = False
LOCKERS_MODULES_PREFIX = 'lockers.modules'

def wrap_middleware(app):
    return session.SessionMiddleware(app)

dir = os.path.abspath(os.path.dirname(__file__))
def make_app():
    constructors = {}
    modules_dir = os.path.join(dir, 'modules')

    return URLParser({}, modules_dir,
                     LOCKERS_MODULES_PREFIX, constructors=constructors)


class LockersMain(object):
    def __init__(self):
        self.app = make_app()
        self.app = wrap_middleware(self.app)

    def __call__(self, environ, start_response):
        # I don't want to assume we'll always be running in /, so let's store
        # the URL for this script itself, so we can include it in generated
        # URLs.
        #
        # Storing it in the environ is the most portable thing. We only
        # use it in the Node class.
        global lockers
        environ['ORIG_SCRIPT'] = environ.get('ORIG_SCRIPT', environ['SCRIPT_NAME'])
        app = self.app

        response = app(lockers.request.LockersRequest(environ))
        if isinstance(response, (str, unicode)): response = Response(response)
        return response(environ, start_response)

if __name__ == '__main__':
    # FIXME: getopt
    if '--devel' in sys.argv:
        DEVEL = True
        sys.argv.remove('--devel')

    if '--run' in sys.argv:
        # Hack to run single files with correct sys.path etc.
        index = sys.argv.index('--run')
        cmd = sys.argv[index+1]
        del sys.argv[index:index+2]
        exec(cmd)
        sys.exit()

    # To show off the pony stuff, do:
    # import paste.pony
    # lockers_app = paste.pony.PonyMiddleware(LockersMain())
    lockers_app = LockersMain()

    from paste import httpserver
    httpserver.serve(lockers_app, host='127.0.0.1', port='8080')
