from __future__ import with_statement
import os
from lockers import application
from lockers import backend
from lockers.node import Node
from lockers.vcs import Git

def init(repoloc):
    if os.getcwd() == repoloc: return
    application.REPOROOT = repoloc
    os.system("rm -rf "+ application.REPOROOT)
    try:
        os.makedirs(application.REPOROOT)
    except:
        pass

    os.chdir(application.REPOROOT)
    backend.unset_backend()
    b = backend.make_backend(Git.create())

    # NOTE: This circumvents the default copying-templates behavior of
    # Application. That's fine for this but we really need to test
    # that too!
    with b.new_transaction() as t:
        n = Node('TEST', '/')
        t.save_part(n, 'README', 'Test repo, not suitable for real use\n')
        t.commit('OK')

