'''
files/
   000000000   # len -> 9
   ...
   000000014

Temporally, the relationship is: revision i committed object i created
at node i.
'''
from __future__ import with_statement
from lockers.models.models import LockersObject, Changeset, ModelFactory
from lockers.models.fields import NumField
from lockers.node import Node


class D2Object_1(LockersObject):
    age = NumField()

D2Object = ModelFactory('D2Object')

populated = False

nodes = []
objects = []
revisions = []
def populate(backend):
    if hasattr(backend, 'populated_dataset2'): return nodes, objects, revisions
    backend.populated_dataset2 = True

    for i in range(15):
        with backend.new_transaction() as t:
            n = Node('files', '/%0.9d'%i)
            obj = D2Object.new(t, n)
            obj.age = ((i+11)*17)%19
            obj.save(Changeset({'message': 'Create object %d'%i}))
            nodes.append(n)
            objects.append(n)
        revisions.append(backend.current_revision())

    return nodes, objects, revisions

