#! /usr/bin/python
# locking_process.py: a process which locks/unlocks the current directory,
#   used in testing lockers.Lock.
import sys
import time
import TestSupport
import lockers.Lock as Lock

locktype = {'read': Lock.READING, 'write': Lock.WRITING}
start = {'read': '(', 'write': '['}
end = {'read': ')', 'write': ']'}

# So for "read", we get a non-exclusive Lock which writes ( when it
# gets the Lock and ) when it releases it.

def locking_process(style, init, middle):
    f = file('results', 'a+')
    time.sleep(init)
    l = Lock.Lock(".")
    l.lock(locktype[style])
    f.write(start[style])
    f.flush()
    time.sleep(middle)
    f.write(end[style])
    f.flush()
    l.unlock()

argv = sys.argv[1:] + [None, '0', '1'][len(sys.argv)-1:]

readorwrite, init, middle = argv
init, middle = float(init), float(middle)
locking_process(readorwrite, init, middle)
