from __future__ import with_statement
from __init__ import TestSupport
import run
from lockers import application
from lockers.node import Node
from lockers import backend

from contrib import fixture
from test import TestApplication
import webob.exc

SHA1FILE = 'assets/sha1.js'
class WikiTests(TestSupport.TestCase):
    def setUp(self):
        TestApplication.init('/tmp/assetstest')
        self.lockers = run.LockersMain()
        self.testapp = fixture.TestApp(self.lockers)
        self.backend = backend.make_backend()

    def test_static(self):
        res = self.testapp.get('/'+SHA1FILE)
        res = self.testapp.get('/assets/fobobobocmjusth', status=404)

    def test_dynamic(self):
        res = self.testapp.get('/'+SHA1FILE)
        vcs = self.backend.vcs
        vcs.dump('templates/'+SHA1FILE, '//hey guys\n')
        vcs.add('templates/'+SHA1FILE)
        vcs.commit('templates/'+SHA1FILE, 'Override built-in sha1.js')
        res2 = self.testapp.get('/'+SHA1FILE)
        self.assertEqual(res2.body, '//hey guys\n')

TestSupport.run(__name__)
