import TestSupport
import lockers.format.rst as rst
import lockers.backend as backend

class RSTTests(TestSupport.TestCase):
    initialized = False
    def setUp(self):
        vcs = TestSupport.TestVCS()
        backend.unset_backend()
        backend.make_backend(vcs)
        self.vcs = vcs
        self.vcs.add_files('wiki/words', 'exceptional', 'ab *cd* ef')

    def test_run(self):
        r = rst.RST()
        self.assertEqual(r.format('sup *words*?'),
                         '<p>sup <em>words</em>?</p>\n')

    def test_wikilink(self):
        r = rst.RST()
        self.assert_(rst.test_valid_link(r.format('sup [[words]]?')))
        self.assert_(rst.test_invalid_link(r.format('sup [[whioho]]?')))

        #self.assertEqual(rst.test_invalid_link(r.format('sup [[abc` def]]')),
        #                 'abc` def')
        self.assertEqual(rst.test_valid_link(r.format('sup [[ab *cd* ef]]')),
                         'ab *cd* ef')

TestSupport.run(__name__)
