from __future__ import with_statement
import syck
import TestSupport
import run
from lockers import application
from lockers.node import Node
from lockers import backend
from lockers import session

from contrib import fixture
from test import TestApplication

class SessionTests(TestSupport.TestCase):
    def setUp(self):
        TestApplication.init('/tmp/sessiontest')
        self.lockers = run.LockersMain()
        self.testapp = fixture.TestApp(self.lockers)
        self.backend = backend.get_backend()

    def test_session(self):
        res = self.testapp.get('/__echo')
        dct = syck.load(res.body)

        self.assertEqual(dct['session'], {})

        res = self.testapp.get('/test/session')
        res = self.testapp.get('/__echo')
        dct = syck.load(res.body)
        self.assert_(dct['session']['counter'] == 1)

        for i in range(3):
            res = self.testapp.get('/test/session')

        res = self.testapp.get('/__echo')
        dct = syck.load(res.body)
        self.assert_(dct['session']['counter'] == 4)

TestSupport.run(__name__)
