import TestSupport
import lockers.template as template
from lockers.node import Node
from lockers.request import LockersRequest
Request = LockersRequest

# Test that reloading the template class doesn't break anything
reload(template)

#import django.template.defaulttags
#print django.template.defaulttags.register.tags
# url_to only shows up once (because it's a dict)

class TestContext(dict):
    def resolve_variable(self, key):
        return self.get(key)

class TestParser(object):
    pass

class TestToken(object):
    def __init__(self, contents):
        self.contents = contents

class TemplateTests(TestSupport.TestCase):
    def setUp(self):
        request = Request.blank('/wiki/Memes/Series_of_Tubes')
        request.path_info_pop()
        request.environ['ORIG_SCRIPT'] = ''
        node = Node(request)
        self.ctx = TestContext({'node': node, 'revid': 123})

    def test_url_to(self):
        # FIXME: ordering
        n = template.url_to_tag(None, TestToken("url_to action=\"edit\", revision=revid"))
        # XHTML: &amp; instead of &
        self.assertEqual(n.render(self.ctx), "http://localhost:80/wiki/Memes/Series_of_Tubes?revision=123&amp;action=edit")

        t = template.Template("{% url_to action=\"edit\", revision=revid %}")
        self.assertEqual(t.render(self.ctx), "http://localhost:80/wiki/Memes/Series_of_Tubes?revision=123&amp;action=edit")


TestSupport.run(__name__)

