from __future__ import with_statement

import TestSupport
import TestApplication

from webob import Response
import lockers.user as user
import lockers.backend as backend
import lockers.vcs as vcs
from lockers.request import LockersRequest
from lockers.models.models import Changeset
import dataset3


class UserTests(TestSupport.TestCase):
    def setUp(self):
        if not hasattr(self, 'users_setup'):
            self.users_setup = True

            TestApplication.init('/tmp/backendtest')
            self.backend = backend.get_backend()
            dataset3.run(self.backend)
            self.USER1_PW, self.USER2_PW = self.backend.d3_passwords[:2]
            self.user1, self.user2 = self.backend.d3_users[:2]

    def test_login1(self):
        r = LockersRequest.blank('/user/login', {
                'username': 'barbie', 'password': self.USER1_PW})

        # Need to define a new function to invoke the SessionMiddleware
        def next(request):
            with self.backend.new_transaction() as t:
                u = user.UserObject.get(t, request)
                self.assert_(u.is_authenticated())
                # FIXME: an equality operator on objects
                self.assertEqual(u.index.realname, self.user1.index.realname)
                return Response('OK')

        self.request_call_function(r, next)


        r = LockersRequest.blank('/user/login', {
                'username': 'barbie', 'password': ''})
        def next(request):
            with self.backend.new_transaction() as t:
                u = user.UserObject.get(t, request)
                self.assert_(not u.is_authenticated())
                return Response('OK')

        self.request_call_function(r, next)
        r = LockersRequest.blank('/user/login', {
                'username': 'barbie', 'password': self.USER2_PW})
        self.request_call_function(r, next)

TestSupport.run(__name__)
